﻿
#pragma warning (disable: 4819) 

/**
* @headerfile			tcua 头文件
*/
#include <server_exits/user_server_exits.h>
#include "epm_register_handler.h"
#include <tccore/custom.h>
#include "connor_itk_util.h"
#ifdef __cplusplus
extern "C" {
#endif


	/**
	* @fn					extern "C" DLLAPI int liborigin_register_callbacks
	* @return				usually return ITK_ok
	* @brief				liborigin customization entry
	* 此函数必须有规范的写法，必须以dll的名称加上"_"开头
	*/

	DLLAPI int mdbks_connor_itk_register_callbacks()
	{

		char* log_file = NULL;

		printf("创建日志文件\n");
		char* TO_SRM = (char*)malloc(sizeof("Main"));
		strcpy(TO_SRM, "Main");
		CreateLogFile(TO_SRM, &log_file);

		int ifail = ITK_ok;
		WriteLog("*******************************************************************************\n");
		WriteLog("*           mdbks_connor_itk register_callbacks  is starting                  *\n");
		WriteLog("*******************************************************************************\n");


		ITKCALL( ifail = CUSTOM_register_exit("mdbks_connor_itk","USER_gs_shell_init_module",
		(CUSTOM_EXIT_ftn_t)USERSERVICE_custom_register_handlers) );
		fprintf( stdout, "\n mdbks_connor_itk	registering USERSERVICE_custom_register_handlers completed!\n" );
		WriteLog("mdbks_connor_itk	registering USERSERVICE_custom_register_handlers completed!");
		ITKCALL(ifail = CUSTOM_register_exit("mdbks_connor_itk", "USERSERVICE_register_methods",
			(CUSTOM_EXIT_ftn_t)USERSERVICE_custom_register_methods));
		fprintf(stdout, "\n mdbks_connor_itk	registering USERSERVICE_custom_register_methods completed!\n");
		WriteLog("mdbks_connor_itk	registering USERSERVICE_custom_register_methods completed!");
		CloseLog();
		return ifail;
	}

#ifdef __cplusplus
}
#endif