//#include <epm/epm.h>
#include <tc/preferences.h>
#include <tccore\aom_prop.h>
#include <bom/bom.h>
#include <tccore/aom.h>
//#include <windows.h>
//#include <vector>
#include <map>
#include <tccore/item.h>
#include <tccore/item.h>
#include <tccore/grmtype.h>
#include <tccore/grm.h>
#include <sa/am.h>
#include <tccore/aom.h>
#include <tccore/aom_prop.h>
#include <property/prop_errors.h>
#include <tccore/tctype.h>
#include <res/res_itk.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <vector>
#include "mdbks_register.h"
#include <chrono>
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
#include <sstream>
#include <tc\preferences.h>
#include <fstream>
#include <filesystem>
#include <windows.h>
#include <direct.h>
using namespace std;

string getMEINH(tag_t rev);


string getFh6_BOP(tag_t parent_rev, char** itemId) {
	boolean isHaveItem = false;
	int n_references = 0;
	int* levels = 0;
	tag_t* references_tag = NULLTAG;
	char** relation_type_name = NULL;
	string json = "";
	string ktext = "";
	ktext.append("\"\"").append("KTEXT").append("\"\":\"\"");
	string datuv = "";
	datuv.append("\"\"").append("DATUV").append("\"\":\"\"");
	string meinh = "";
	meinh.append("\"\"").append("MEINH").append("\"\":\"\"");
	WSOM_where_referenced(parent_rev, 1, &n_references, &levels, &references_tag, &relation_type_name);;
	for (int i = 0; i < n_references; i++) {
		char* objectType = NULL;
		AOM_ask_value_string(references_tag[i], "object_type", &objectType);
		// BOM汾Fh6_TechnologyRevisionǹڳƷ汾Fh6_ProductRevision
		// Ʒ汾Fh6_SemiProductRevisionBOPFh6_BOPϵ
		if (strcmp("Fh6_ProductRevision", objectType) == 0 || strcmp("Fh6_SemiProductRevision", objectType) == 0) {
			// ȡ
			char* objectName = NULL;
			AOM_ask_value_string(references_tag[i], "object_name", &objectName);
			// ȡ
			char* fh6_cj = NULL;
			AOM_ask_value_string(references_tag[i], "fh6_cj", &fh6_cj);
			// ȡɹʽ
			char* fh6_cgfs = NULL;
			AOM_ask_value_string(references_tag[i], "fh6_cgfs", &fh6_cgfs);
			// ȡ汾
			char* item_revision_id = NULL;
			AOM_ask_value_string(references_tag[i], "item_revision_id", &item_revision_id);
			// ƴƣobject_name+(fh6_cj)+ɹʽ(fh6_cgfs)+ƷƷ汾ϵİ汾ԣitem_revision_id
			ktext.append(objectName);
			ktext.append(fh6_cj);
			ktext.append(fh6_cgfs);
			ktext.append(item_revision_id);
			// ȡ
			date_t date_released = NULLDATE;
			AOM_ask_value_date(references_tag[i], "date_released", &date_released);
			datuv.append(to_string(date_released.year));
			string month = to_string(date_released.month + 1);
			if (month.length() == 1) {
				datuv.append("0").append(month);
			}
			else {
				datuv.append(month);
			}
			string day = to_string(date_released.day);
			if (day.length() == 1) {
				datuv.append("0").append(day);
			}
			else {
				datuv.append(day);
			}
			// ȡid
			AOM_ask_value_string(references_tag[i], "item_id", itemId);
			// ȡϵλ
			string MEINH = getMEINH(references_tag[i]);
			meinh.append(MEINH);

		}
	}
	json.append(ktext).append("\"\",").append(datuv).append("\"\",").append(meinh).append("\"\"");
	return json;
}

string getZZBOM(tag_t parent_rev, string item_id, tag_t** ZZBOM, int* zzbomline) {
	WriteLog("%s	-------GETZZBOMSTART:-------", getNow("LOG").c_str());
	boolean isHaveItem = false;
	int n_references = 0;
	int* levels = 0;
	tag_t* references_tag = NULLTAG;
	char** relation_type_name = NULL;
	string json = "";
	int zzbomlineInd = 0;
	WSOM_where_referenced(parent_rev, 1, &n_references, &levels, &references_tag, &relation_type_name);
	for (int i = 0; i < n_references; i++) {
		char* objectType = NULL;
		AOM_ask_value_string(references_tag[i], "object_type", &objectType);
		// հ汾Fh6_TechnologyRevisionҲBOM汾Fh6_ZZBOMRevision
		// BOPFh6_BOPϵ
		if (strcmp("Fh6_ZZBOMRevision", objectType) == 0) {
			if (zzbomlineInd > 0) {
				json.append(",");
			}
			//BOMWindow
			tag_t top_line = NULLTAG, window = NULLTAG;
			// WriteLog("%s	BOMWindow", getNow("LOG").c_str());
			ITKCALL(BOM_create_window(&window));
			//öBOM
			// WriteLog("%s	öBOM", getNow("LOG").c_str());
			ITKCALL(BOM_set_window_top_line(window, NULLTAG, references_tag[i], NULLTAG, &top_line));
			tag_t* children_line = NULLTAG;
			char* id = NULL, * objname = NULL;
			int itemNum;
			tag_t* items = NULL;
			// WriteLog("%s	ȡBOM", getNow("LOG").c_str());
			//ΪݹȡBOM㼶
			ITKCALL(BOM_line_ask_all_child_lines(top_line, &itemNum, &items));
			ZZBOM = &items;
			zzbomline = &itemNum;
			WriteLog("%s	ȡBOM%d,ʼbom", getNow("LOG").c_str(), itemNum);
			for (int itemind = 0; itemind < itemNum; itemind++) {
				WriteLog("%s	%d,", getNow("LOG").c_str(), itemind);
				if (itemind != 0) {
					json.append(",");
				}
				string itemJson = "{";
				string stlnr = "";
				stlnr.append("\"\"").append("STLNR").append("\"\":\"\"");
				string stlal = "";
				stlal.append("\"\"").append("STLAL").append("\"\":\"\"");
				string posnr = "";
				posnr.append("\"\"").append("POSNR").append("\"\":\"\"");
				string vornr = "";
				vornr.append("\"\"").append("VORNR").append("\"\":\"\"");
				// ȡϵ
				char* Fh6wld = NULL;
				AOM_ask_value_string(items[itemind], "Fh6wld", &Fh6wld);
				stlnr.append(Fh6wld).append("\"\"");
				// ȡѡbom
				char* Fh6kxybom = NULL;
				AOM_ask_value_string(items[itemind], "Fh6kxybom", &Fh6kxybom);
				stlal.append(Fh6kxybom).append("\"\"");
				// ȡBOMĿ
				char* bl_sequence_no = NULL;
				AOM_ask_value_string(items[itemind], "bl_sequence_no", &bl_sequence_no);
				//sapʱֵԶǰ0Ϊ4λֵ
				int len = tc_strlen(bl_sequence_no);
				if (len == 0) {
					posnr.append("0000").append(bl_sequence_no).append("\"\"");
					vornr.append("0000").append(bl_sequence_no).append("\"\"");
				}
				else if (len == 1) {
					posnr.append("000").append(bl_sequence_no).append("\"\"");
					vornr.append("000").append(bl_sequence_no).append("\"\"");
				}
				else if (len == 2) {
					posnr.append("00").append(bl_sequence_no).append("\"\"");
					vornr.append("00").append(bl_sequence_no).append("\"\"");
				}
				else if (len == 3) {
					posnr.append("0").append(bl_sequence_no).append("\"\"");
					vornr.append("0").append(bl_sequence_no).append("\"\"");
				}
				else if (len == 4) {
					posnr.append(bl_sequence_no).append("\"\"");
					vornr.append(bl_sequence_no).append("\"\"");
				}
				else {
					posnr.append(bl_sequence_no).append("\"\"");
					vornr.append(bl_sequence_no).append("\"\"");
				}
				// ȡBOM 
				char* idnrkVal = NULL;
				AOM_ask_value_string(items[itemind], "awb0BomLineItemId", &idnrkVal);
				itemJson.append(stlnr).append(",").append(stlal).append(",").append(posnr).append(",").append(vornr);
				itemJson.append(",\"\"").append("MATNR").append("\"\":\"\"").append(item_id).append("\"\"");
				string itemidWith18 = "";
				if (strlen(idnrkVal) < 18) {
					int zerosize = 18 - strlen(idnrkVal);
					while (zerosize--) {
						itemidWith18.append("0");
					}
				}
				itemJson.append(",\"\"").append("IDNRK").append("\"\":\"\"").append(itemidWith18).append(idnrkVal).append("\"\"");
				itemJson.append("}");
				json.append(itemJson);
			}
			zzbomlineInd++;
			WriteLog("%s	-------GETZZBOMEND;----------", getNow("LOG").c_str());
			return json;
		}
	}

	WriteLog("%s	-------GETZZBOMEND;----------", getNow("LOG").c_str());
	return json;
}
/*
	ͨ汾ȡ̧ͷjson
	rev 汾
	props ҪȡԼ
*/
string getTABLEJson(tag_t rev, map< string, string > props, string type) {
	string json = "";
	map<string, string>::iterator it;
	for (it = props.begin(); it != props.end(); it++) {
		string key = it->first;
		string prop = props[key];
		char* value = NULL;
		ITKCALL(AOM_UIF_ask_value(rev, prop.c_str(), &value));
		if (json.size() > 1)
			json.append(",");
		if (tc_strcmp(prop.c_str(), "bl_sequence_no") == 0) {
			//sapʱֵԶǰ0Ϊ4λֵ
			int len = tc_strlen(value);
			if (len == 0) {
				json.append("\"\"").append(key).append("\"\":\"\"").append("0000").append("\"\"");
			}
			else if (len == 1) {
				json.append("\"\"").append(key).append("\"\":\"\"").append("000").append(value).append("\"\"");
			}
			else if (len == 2) {
				json.append("\"\"").append(key).append("\"\":\"\"").append("00").append(value).append("\"\"");
			}
			else if (len == 3) {
				json.append("\"\"").append(key).append("\"\":\"\"").append("0").append(value).append("\"\"");
			}
			else if (len == 4) {
				json.append("\"\"").append(key).append("\"\":\"\"").append("0").append(value).append("\"\"");
			}
			else {
				json.append("\"\"").append(key).append("\"\":\"\"").append(value).append("\"\"");
			}
		}
		else if (tc_strcmp(prop.c_str(), "Fh6kzm") == 0 || tc_strcmp(prop.c_str(), "Fh6gzzx") == 0) {
			ITKCALL(AOM_ask_value_string(rev, prop.c_str(), &value));
			json.append("\"\"").append(key).append("\"\":\"\"").append(value).append("\"\"");
		}
		else {
			if (tc_strcmp(type.c_str(), "C") == 0 && (tc_strcmp(key.c_str(), "PLNNR") == 0 || tc_strcmp(key.c_str(), "PLNAL") == 0)) {
				// 
				value = "";
			}
			json.append("\"\"").append(key).append("\"\":\"\"").append(value).append("\"\"");
		}
	}
	// Ĭϴ
	json.append(",\"\"UMREN\"\":\"\"").append("1").append("\"\"");
	json.append(",\"\"UMREZ\"\":\"\"").append("1").append("\"\"");
	//json.append(",\"\"ZGGBS\"\":\"\"").append(update).append("\"\",\"\"bom\"\":[");
	//json.append(",\"\"bom\"\":[");
	json.append(",\"\"STATU\"\":\"\"").append("4").append("\"\"");
	json.append(",\"\"VERWE\"\":\"\"").append("1").append("\"\"");

	json.append(",\"\"UVORN\"\":\"\"").append("").append("\"\"");
	return json;
}

/*
	BOMʾļλֶΣMEINHȡbomӼ϶Itemuom_tagԣעϰ汾ԣ
*/
string getMEINH(tag_t rev) {
	string json = "";
	int n_references = 0, n_references1 = 0;
	int* levels = 0, * levels1 = 0;
	tag_t* references_tag = NULLTAG;
	tag_t* references_tag1 = NULLTAG;
	char** relation_type_name = NULL;
	char** relation_type_name1 = NULL;
	int zzbomlineInd = 0;
	WSOM_where_referenced(rev, 1, &n_references1, &levels1, &references_tag1, &relation_type_name1);
	for (int j = 0; j < n_references1; j++) {
		char* objectType1 = NULL;
		AOM_ask_value_string(references_tag1[j], "object_type", &objectType1);
		if (
			strcmp("Fh6_AuxItem", objectType1) == 0 ||
			strcmp("Fh6_MainItem", objectType1) == 0 ||
			strcmp("Fh6_Jig", objectType1) == 0 ||
			strcmp("Fh6_RawMaterial", objectType1) == 0 ||
			strcmp("Fh6_Product", objectType1) == 0 ||
			strcmp("Fh6_SemiProduct", objectType1) == 0 ||
			strcmp("Fh6_MoldHalfItem", objectType1) == 0 ||
			strcmp("Fh6_MoldItem", objectType1) == 0 ||
			strcmp("Fh6_Guest", objectType1) == 0 ||
			strcmp("Fh6_GuestOther", objectType1) == 0
			) {
			// ȡλ
			char* MEINH;
			//tag_t jbdldw = NULLTAG;
			//ITEM_ask_item_of_rev(references_tag1[j], &jbdldw);
			tag_t dw = NULLTAG;
			AOM_ask_value_tag(references_tag1[j], "uom_tag", &dw);
			AOM_ask_value_string(dw, "object_string", &MEINH);
			json.append(MEINH);
			return json;
		}
	}
	return json;
}


string getKTSCH_LTXA1(tag_t rev) {
	string json = "";
	tag_t item_tag;
	ITKCALL(AOM_ask_value_tag(rev, "bl_line_object", &item_tag));//ȡBOMLINİ汾
	if (item_tag != NULL) {
		// ׼ı 
		char* fh6_bzwbm = NULL;
		AOM_ask_value_string(item_tag, "fh6_bzwbm", &fh6_bzwbm);
		json.append("\"\"KTSCH\"\":\"\"").append(fh6_bzwbm).append("\"\"");
		// ı 
		char* fh6_gxdwb = NULL;
		AOM_ask_value_string(item_tag, "fh6_gxdwb", &fh6_gxdwb);
		json.append(",\"\"LTXA1\"\":\"\"").append(fh6_gxdwb).append("\"\"");
	}
	if (json.empty()) {
		json.append("\"\"KTSCH\"\":\"\"").append("").append("\"\"");
		json.append(",\"\"LTXA1\"\":\"\"").append("").append("\"\"");
	}
	return json;
}

int Connor_BOP_SAP(EPM_action_message_t msg)
{
	int ifail = ITK_ok, target_count = 0;
	tag_t pRoot = NULLTAG, * targets = NULL;
	char* address = NULL;
	// ȡʲôַ
	ITKCALL(PREF_ask_char_value("PHZD_sap_mbom_url", 0, &address));
	if (!address || tc_strlen(address) == 0) {
		ifail = 919040;
		EMH_store_error_s1(EMH_severity_user_error, ifail, "PHZD_sap_mbom_url");
		return ifail;
	}
	// ־
	string log_path = getenv("temp");
	log_path.append("\\BOPSENDSAPLogs").append(getNow("yyyyMMdd")).append(".log");
	CreateLogFile(log_path.c_str());

	map< string, string > bomlineInfo;
	//tbop["WERKS"] = "fh6gc";//
	bomlineInfo["PLNTY"] = "Fh6rwqdlx";//嵥
	bomlineInfo["PLNNR"] = "Fh6rwqdzm";//嵥
	bomlineInfo["PLNAL"] = "Fh6zjsq";//
	//bomlineInfo["VERWE"] = "Fh6rwqdsy";//嵥ʹ Ĭϴ1
	//bomlineInfo["STATU"] = "Fh6zt";//״̬  Ĭ4
	// ȡbomlineϵĲұbl_sequence_noԣsapʱֵԶǰ0Ϊ4λֵݸsap
	// ұΪ10򴫵ݵsapʱֵΪ0010ұΪ399򴫵sapʱֵΪ0399
	bomlineInfo["VORNR"] = "bl_sequence_no";//
	// ȡbomlineϵĲұԣsapʱֵԶǰ0Ϊ4λֵݸsap
	// ұΪ10򴫵ݵsapʱֵΪ0010ұΪ399򴫵sapʱֵΪ0399
	//bomlineInfo["UVORN"] = "bl_sequence_no";//ӹ 
	bomlineInfo["ARBPL"] = "Fh6gzzx"; //
	bomlineInfo["STEUS"] = "Fh6kzm"; //
	bomlineInfo["BMSCH"] = "bl_quantity"; //
	bomlineInfo["VGW01"] = "Fh6rggs"; //׼ֵ ǰ̨ʾ ˹ʱ
	bomlineInfo["VGE01"] = "Fh6rggsdw"; //׼ֵλ ǰ̨ʾ˹ʱλ
	bomlineInfo["VGW02"] = "Fh6jqgs"; //׼ֵ  ǰ̨ʾ ʱ
	bomlineInfo["VGE02"] = "Fh6jqgsdw"; //׼ֵλ  ǰ̨ʾ ʱλ
	bomlineInfo["AUFAK"] = "Fh6bfyz"; //
	bomlineInfo["CKSELKZ"] = "Fh6ycbhsxgbs"; //ɱر־

	string err_msg = "";
	// ȡҵĸ
	// WriteLog("%s	ȡҵĸ:%d", getNow("LOG").c_str(), target_count);
	ITKCALL(EPM_ask_root_task(msg.task, &pRoot));

	// ָлȡض͵и
	ITKCALL(EPM_ask_attachments(pRoot, EPM_target_attachment, &target_count, &targets));
	// WriteLog("%s	ָлȡض͵и:%d", getNow("LOG").c_str(), target_count);
	string jsons = "{";
	string tbopjson = "[";
	string tplmzjson = "[";
	tag_t targetObj = NULL;
	int itemNum = 0;
	tag_t* items;
	tag_t* zzbom = NULL, window = NULLTAG;
	int zzbomNums;
	//BOMWindow
	tag_t top_line = NULLTAG;
	for (int t = 0; t < target_count; t++) {
		char* type = NULL;
		// ȡ
		ITKCALL(WSOM_ask_object_type2(targets[t], &type));
		// WriteLog("%s	ȡ:%s", getNow("LOG").c_str(), type);
		if (tc_strcmp(type, "Fh6_TechnologyRevision") == 0) {
			// ȡֵԵֵ
			char* fh6_cdzt = NULL;// ȡϰ汾ϵfh6_cdztԣֵΪգıʶCֵΪɣıʶU
			ITKCALL(AOM_ask_value_string(targets[t], "fh6_cdzt", &fh6_cdzt));
			string update;
			if (tc_strcmp(fh6_cdzt, "") == 0) {
				update = "U";
			}
			else {
				update = "C";
			}
			// ȡֵԵֵ
			char* item_id = NULL;// ȡBOM汾Fh6_TechnologyRevisionϵitem_id 
			// WriteLog("%s	BOMWindow", getNow("LOG").c_str());
			ITKCALL(BOM_create_window(&window));
			//öBOM
			// WriteLog("%s	öBOM", getNow("LOG").c_str());
			ITKCALL(BOM_set_window_top_line(window, NULLTAG, targets[t], NULLTAG, &top_line));
			tag_t* children_line = NULLTAG;
			char* id = NULL, * objname = NULL, * guige = NULL, * jishu = NULL, * shengc = NULL, * biaoji = NULL, * paihao = NULL, * yuanyin = NULL;
			char* type1 = "item", * type2 = "itemrevision", * type3 = "revmaster";
			vector<char*> ids, objnames, guiges, jishus, shengcs, biaojis, paihaos, yuanyins;
			// WriteLog("%s	ȡBOM", getNow("LOG").c_str());
			//ΪݹȡBOM㼶
			ITKCALL(BOM_line_ask_all_child_lines(top_line, &itemNum, &items));
			string relation_json = getFh6_BOP(targets[t], &item_id);
			// WriteLog("%s	ȡBOM%d", getNow("LOG").c_str(), itemNum);
			for (int itemind = 0; itemind < itemNum; itemind++) {
				if (itemind != 0) {
					tbopjson.append(",");
				}
				tbopjson.append("{");
				//ȡT_BOP
				string tbopjson1 = getTABLEJson(items[itemind], bomlineInfo, update);
				string ktschAndLtxa1 = getKTSCH_LTXA1(items[itemind]);
				tbopjson.append(tbopjson1);
				tbopjson.append(",\"\"").append("MATNR").append("\"\":\"\"").append(item_id).append("\"\"");
				tbopjson.append(",\"\"").append("ZGGBS").append("\"\":\"\"").append(update).append("\"\"");
				//tbopjson.append(",\"\"").append("MEINH").append("\"\":\"\"").append(MEINH).append("\"\"");
				tbopjson.append(",").append(ktschAndLtxa1);
				tbopjson.append(",").append(relation_json).append("}");
			}
			// WriteLog("%s	ȡBOM", getNow("LOG").c_str());
			//ȡT_PLMZ
			string tplmzjson1 = getZZBOM(targets[t], item_id, &zzbom, &zzbomNums);
			// WriteLog("%s	ȡT_PLMZ", getNow("LOG").c_str());
			tplmzjson.append(tplmzjson1);
			targetObj = targets[t];
			BOM_save_window(window);
		}
		if (tc_strcmp(type, "BOMView Revision") == 0) {
		}
	}
	tbopjson.append("]");
	tplmzjson.append("]");
	jsons.append("\"\"T_BOP\"\":").append(tbopjson);
	jsons.append(",\"\"T_PLMZ\"\":").append(tplmzjson);
	jsons.append("}");
	WriteLog("%s	׼:", getNow("LOG").c_str());
	string cmd = "java -jar \"";
	cmd.append(getenv("TC_ROOT")).append("\\bin\\bop\\sapjco3.jar\" BOP \"").append(jsons).append("\" \"").append(address).append("\"");//connor_send//sapjco3
	//printf("cmd:%s\n", cmd.c_str());
	WriteLog("%s	cmd:%s", getNow("LOG").c_str(), cmd.c_str());
	log_close();
	//system(cmd.c_str());
	string result;
	char buf[8000] = { 0 };
	FILE* pf = _popen(cmd.c_str(), "r");
	while (fgets(buf, sizeof buf, pf)) {
		result.append(buf);
	}
	_pclose(pf);
	log_open();
	WriteLog("result:%s\n", result.c_str());
	vector<string> rs;
	Split(result, "@", rs);
	vector<string> rs1;
	Split(rs[1], "#", rs1);
	if (strcmp(rs[0].c_str(), "S") == 0 && strcmp(rs1[1].c_str(), "S") == 0) {
		// 2501
		vector<string> rs25012;
		Split(rs1[0], ":", rs25012);
		vector<string> rs25013;
		Split(rs25012[1], "&", rs25013);
		// 2502
		vector<string> rs25021;
		Split(rs[2], "#", rs25021);
		WriteLog("rs25021.size:%d\n", rs25021.size());
		vector<string> rs25022;
		Split(rs25021[0], ":", rs25022);
		WriteLog("rs25022.size:%d\n", rs25022.size());
		vector<string> rs25023;
		Split(rs25022[1], "&", rs25023);
		WriteLog("rs25023.size:%d\n", rs25023.size());
		AOM_lock(targetObj);
		int bvr_count = 0;
		tag_t* bvr_list;
		ITKCALL(ITEM_rev_list_bom_view_revs(targets[t], &bvr_count, &bvr_list));
		ITKCALL(AOM_lock(top_line));
		for (int itemind = 0; itemind < itemNum; itemind++) {
			//ITKCALL(AOM_lock(items[itemind]));
			string plnnr = "";
			if (!rs25013[0].empty()) {
				plnnr.append(rs25013[0].c_str());
			}
			if (!rs25023[0].empty()) {
				plnnr.append("&").append(rs25023[0].c_str());
			}
			ITKCALL(AOM_set_value_string(items[itemind], "Fh6rwqdzm", plnnr.c_str()));
			string plnal = "";
			if (!rs25013[1].empty()) {
				plnal.append(rs25013[1].c_str());
			}
			if (!rs25023[1].empty()) {
				plnal.append("&").append(rs25023[1].c_str());
			}
			ITKCALL(AOM_set_value_string(items[itemind], "Fh6zjsq", plnal.c_str()));
			ITKCALL(AOM_save(items[itemind]));
			ITKCALL(AOM_unlock(items[itemind]));
		}
		ITKCALL(AOM_save(top_line));
		ITKCALL(AOM_unlock(top_line));
		//ݳɹԡfh6_cdztΪɡ
		POM_AM__set_application_bypass(true);
		ITKCALL(AOM_set_value_string(targetObj, "fh6_cdzt", ""));
		ITKCALL(AOM_save(targetObj));
		ITKCALL(AOM_unlock(targetObj));
	}
	else {
		ifail = 919080;
		//ʧ򱨴ѣֵΪʧܡ
		//AOM_lock(targetObj);
		char* fh6_cdzt = NULL;// ȡϰ汾ϵfh6_cdztԣֵΪգıʶCֵΪɣıʶU
		ITKCALL(AOM_ask_value_string(targetObj, "fh6_cdzt", &fh6_cdzt));
		if (strcmp(fh6_cdzt, "") != 0) {
			ITKCALL(AOM_set_value_string(targetObj, "fh6_cdzt", "ʧ"));
		}
		//POM_AM__set_application_bypass(true);
		//POM_AM__set_application_bypass(false);
		//AOM_save(targetObj);
		//AOM_unlock(targetObj);
		if (rs.size() > 1) {
			err_msg.append(rs[1]).append("\n");
		}
		else {
			err_msg.append(result).append("\n");
		}
	}
	WriteLog("err_msg:%s,ifall:%d\n", err_msg.c_str(), ifail);
	CloseLog();

	if (ifail != ITK_ok) {
		ITKCALL(EMH_store_error_s1(EMH_severity_user_error, ifail, err_msg.c_str()));
	}
	return ifail;
}