#define _CRT_SECURE_NO_WARNINGS
#define EPM_HANDLER_COMMON

#include <tccore/item.h>
#include <tccore/grmtype.h>
#include <tccore/grm.h>
#include <sa/am.h>
#include <tccore/aom.h>
#include <tccore/aom_prop.h>
#include <property/prop_errors.h>
#include <tccore/tctype.h>
#include <res/res_itk.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <vector>
#include "mdbks_register.h"
#include <chrono>
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
#include <sstream>
#include <tc\preferences.h>
#include <fstream>
#include <filesystem>
#include <windows.h>
#include <direct.h>
#include <io.h>

using namespace std;



// ַתΪ curl_slist 
static struct curl_slist* create_header_list1(const char** headers) {
	struct curl_slist* header_list = NULL;
	for (; *headers != NULL; headers++) {
		header_list = curl_slist_append(header_list, *headers);
	}
	return header_list;
}

#define MAX_BUFFER_SIZE 10000

size_t WriteCallback1(void* contents, size_t size, size_t nmemb, void* userp) {
	size_t totalSize = size * nmemb;
	char* buffer = (char*)userp;
	size_t currentLength = strlen(buffer);

	// ʣռֹ
	if (currentLength + totalSize > MAX_BUFFER_SIZE) {
		printf("Error: Response too large for buffer!\n");
		return 0;
	}

	// ׷ݵ
	strncat(buffer, (char*)contents, totalSize - 1); // 1Ϊ˱'\0'λ
	buffer[currentLength + totalSize - 1] = '\0'; // ӽ

	return totalSize;
}

char* sendPostRequest1(const char* url, const char* file_path, const char* proCode, const char* proName, const char* fileCode, const char* productCode, const char* fileVersion, const char* file_name) {
	CURL* curl;
	CURLcode res;
	char readBuffer[MAX_BUFFER_SIZE];
	memset(readBuffer, 0, MAX_BUFFER_SIZE);
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url);
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		struct curl_slist* headers = NULL;

		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback1);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, readBuffer);

		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		curl_mime* mime;
		curl_mimepart* part;
		mime = curl_mime_init(curl);
		part = curl_mime_addpart(mime);
		curl_mime_name(part, "ProjectCode");
		curl_mime_data(part, proCode, CURL_ZERO_TERMINATED);
		part = curl_mime_addpart(mime);
		curl_mime_name(part, "ProjectName");
		curl_mime_data(part, proName, CURL_ZERO_TERMINATED);
		part = curl_mime_addpart(mime);
		curl_mime_name(part, "FileCode");
		curl_mime_data(part, fileCode, CURL_ZERO_TERMINATED);
		part = curl_mime_addpart(mime);
		curl_mime_name(part, "ProductCode");
		curl_mime_data(part, productCode, CURL_ZERO_TERMINATED);
		part = curl_mime_addpart(mime);
		curl_mime_name(part, "FileVersion");
		curl_mime_data(part, fileVersion, CURL_ZERO_TERMINATED);
		part = curl_mime_addpart(mime);
		curl_mime_name(part, "");
		curl_mime_filedata(part, file_path);
		curl_easy_setopt(curl, CURLOPT_MIMEPOST, mime);
		res = curl_easy_perform(curl);
		curl_mime_free(mime);

		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0L); // ֹ֤Զ֤
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0L); // ֹ֤

		if (res != CURLE_OK) {
			fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
			return NULL;
		}
	}
	else {
		printf("Failed to initialize curl.\n");
		return NULL;
	}

	return readBuffer;
}

//// ʹвļ POST 
//char* send_post_request1(const char* url, const char* file_path, const char* proCode, const char* proName, const char* fileCode, const char* fileVersion,const char* file_name) {
//	CURL* curl = curl_easy_init();
//	if (!curl) {
//		fprintf(stderr, "Failed to initialize curl.\n");
//		return NULL;
//	}
//	char readBuffer[MAX_BUFFER_SIZE];
//	memset(readBuffer, 0, MAX_BUFFER_SIZE);
//	// ò
//	struct curl_httppost* formpost = NULL;
//	struct curl_httppost* lastptr = NULL;
//
//	curl_formadd(&formpost, &lastptr, CURLFORM_COPYNAME, "ProjectCode", CURLFORM_COPYCONTENTS, proCode, CURLFORM_END);
//	curl_formadd(&formpost, &lastptr, CURLFORM_COPYNAME, "ProjectName", CURLFORM_COPYCONTENTS, proName, CURLFORM_END);
//	curl_formadd(&formpost, &lastptr, CURLFORM_COPYNAME, "FileCode", CURLFORM_COPYCONTENTS, fileCode, CURLFORM_END);
//	curl_formadd(&formpost, &lastptr, CURLFORM_COPYNAME, "FileVersion", CURLFORM_COPYCONTENTS, fileVersion, CURLFORM_END);
//	curl_formadd(&formpost, &lastptr, CURLFORM_FILE, file_path, CURLFORM_FILENAME, file_name, CURLFORM_END);
//
//	// ͷ
//	static const char* headers[] = { "Content-Type: multipart/form-data", NULL };
//	struct curl_slist* header_list = create_header_list1(headers);
//
//	// ִ
//	curl_easy_setopt(curl, CURLOPT_URL, url);
//	curl_easy_setopt(curl, CURLOPT_HTTPHEADER, header_list);
//	curl_easy_setopt(curl, CURLOPT_POST, 1L);
//	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback1);
//	curl_easy_setopt(curl, CURLOPT_WRITEDATA, readBuffer);
//	curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "");
//	curl_easy_setopt(curl, CURLOPT_HTTPPOST, formpost);
//
//	curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0L); 
//	curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0L); 
//	CURLcode res;
//	res = curl_easy_perform(curl);
//	if (res != CURLE_OK) {
//		fprintf(stderr, "curl_easy_perform failed: %s\n", curl_easy_strerror(res));
//	}
//
//	// Դ
//	curl_easy_cleanup(curl);
//	curl_formfree(formpost);
//	curl_slist_free_all(header_list);
//
//	return readBuffer;
//}

// ԭͣһµַвԭַеκοո
char* removeSpaces1(const char* input) {
	if (!input) return NULL;

	// ȼȥոַ
	int lenWithoutSpaces = 0;
	for (const char* p = input; *p; ++p) {
		if (*p != ' ') {
			++lenWithoutSpaces;
		}
	}

	// 㹻ڴַ
	char* output = (char*)malloc(lenWithoutSpaces + 1);
	if (!output) return NULL;

	// Ʋոַַ
	int index = 0;
	for (const char* q = input; *q; ++q) {
		if (*q != ' ') {
			output[index++] = *q;
		}
	}
	output[index] = '\0'; // ֹ

	return output;
}


#define MAX_ATTR_LENGTH 100 // 󳤶
//jsonеtokenϢ
const char* extractValueFromJson1(const char* response, const char* attr) {
	// Ƴпո
	char* response2 = removeSpaces1(response);
	printf("response2: %s\n", response2);

	// ʹþ̬飬עattrᳬMAX_ATTR_LENGTHַ
	char attr_with_quotes[2 * MAX_ATTR_LENGTH + 3]; // ˫źð
	snprintf(attr_with_quotes, sizeof(attr_with_quotes), "\"%s\":\"", attr);
	sprintf(attr_with_quotes, "\"%s\":\"", attr);

	const char* value_start = strstr(response2, attr_with_quotes);
	if (value_start == NULL) {
		return NULL; // attr δҵ
	}
	value_start += strlen(attr_with_quotes); // ƶָ뵽ֵʼλ

	const char* value_end = strchr(value_start, '"');
	if (value_end == NULL) {
		return NULL; // ˫δҵ
	}

	// ȷҵǽֵ˫ţǶֵڵ˫
	if (*(value_end - 1) == '\\') {
		do {
			value_end = strchr(value_end + 1, '"');
			if (value_end == NULL) {
				return NULL; // ת˫ţδҵת˫ţ򷵻ش
			}
		} while (*(value_end - 1) == '\\');
	}

	size_t value_length = value_end - value_start;
	char* value = (char*)malloc((value_length + 1) * sizeof(char));
	if (value == NULL) {
		return NULL; // ڴʧ
	}
	strncpy(value, value_start, value_length);
	value[value_length] = '\0'; // ֹ
	printf("value: %s\n", value);

	// ʱ
	free(response2);

	return value;
}


void CreateDirectoryAndFile1(const char* directory_path, const char* file_path) {
	// Ŀ¼·תΪַ
	wchar_t w_directory_path[MAX_PATH];
	MultiByteToWideChar(CP_UTF8, 0, directory_path, -1, w_directory_path, MAX_PATH);

	// ļǷڣ򴴽
	DWORD dwAttrib = GetFileAttributes(w_directory_path);
	if (dwAttrib == INVALID_FILE_ATTRIBUTES || !(dwAttrib & FILE_ATTRIBUTE_DIRECTORY)) {
		// ļвڣԴ
		if (_wmkdir(w_directory_path) != 0) {
			perror("Failed to create directory.");
			return;
		}
	}

	// ļ·תΪַ
	wchar_t w_file_path[MAX_PATH];
	MultiByteToWideChar(CP_UTF8, 0, file_path, -1, w_file_path, MAX_PATH);

	// ļǷڣ򴴽
	FILE* file = fopen(file_path, "r");
	if (file == NULL) {
		// ļڣԴ򿪣׷ģʽ򿪣
		file = fopen(file_path, "a+");
		if (file == NULL) {
			perror("Failed to create and open file.");
			return;
		}
		fclose(file); // رոմļ
	}
	else {
		fclose(file); // ļѴڣرմ򿪵ļ
	}
}

const char* extractLastPart1(const char* url) {
	if (url == nullptr) return nullptr;

	// һ '/' λ
	const char* lastSlash = strrchr(url, '/');

	// Ҳ '/', ԭַҪĲ
	if (lastSlash == nullptr) return url;

	// ƶ '/' ĵһַӴʼλ
	return lastSlash + 1;
}

char* getCurrentTime1() {
	time_t nowtime;
	time(&nowtime); // ȡǰʱ䣨197011
	tm* p = localtime(&nowtime); // תΪʱ

	// ̬仺ȷ㹻ɸʽʱַ
	char* timeStr = (char*)malloc(sizeof(char) * 14); // ʽΪ"YYYYMMDDHHMMSS"14ַ+1'\0'
	if (timeStr == NULL) {
		perror("Memory allocation failed");
		return NULL;
	}

	// ʹsnprintfʽʱ䵽
	int len = snprintf(timeStr, 14, "%04d%02d%02d%02d%02d", p->tm_year + 1900, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min);
	if (len < 0) {
		perror("Failed to format time");
		free(timeStr);
		return NULL;
	}
	else if (len > 14) {
		//ϲᷢΪΪ14ԿӴ˼
		perror("Formatted time exceeds buffer size");
		free(timeStr);
		return NULL;
	}

	return timeStr;
}

/**
 *
 * @HandlerName: KSDY_DrawToMES
 * @HandlerType: ActionHandler
 * @Description: ͨhandleͼֽMES
 * @author: hcj
 * @date: 2024520
 *
 */
int KSDY_DrawToMES(EPM_action_message_t msg) {
	//ȡ
	tag_t rootTask = NULLTAG;
	EPM_ask_root_task(msg.task, &rootTask);
	//ļкļǷ 򴴽
	const char* directory_path = "D:\\log";
	const char* file_path = "D:\\log\\KSDY_DrawToMES.log";
	CreateDirectoryAndFile1(directory_path, file_path);

	//־ļΪ׷ģʽ
	auto logFile = std::make_unique<std::ofstream>("D:\\log\\KSDY_DrawToMES.log", std::ios::app);
	logFile->is_open();

	//ȡǰʱ
	auto now = std::chrono::system_clock::now();
	std::time_t time1 = std::chrono::system_clock::to_time_t(now);
	std::string timeStr = std::ctime(&time1);
	*logFile << "[" << timeStr.substr(0, timeStr.size() - 1) << "] ";
	*logFile << "=========================MESDrawstart===================" << std::endl;

	//ȡѡ
	char* url = NULL;
	ITKCALL(PREF_ask_char_value("KSDY_TC2MES_URL", 1, &url));
	*logFile << "ѡKSDY_TC2MES_URLΪ: " << (url ? url : "δ") << std::endl;

	if (url == NULL || strlen(url) == 0) {
		*logFile << "ѡKSDY_TC2MES_URLδûΪա" << std::endl;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡKSDY_TC2MES_URLδûΪա");
		return -1;
	}
	else {
		// ȷurlЧٵextractMaterialInfo
		url = extractMaterialInfo(url, "Draw:");
		if (url) {
			*logFile << "ȡDrawϢɹ: " << url << std::endl;
		}
		else {
			*logFile << "δܴѡȡDrawϢ" << std::endl;
			// 򷵻ش
		}
	}
	*logFile << "ѡKSDY_TC2MES_URL" << url << std::endl;

	char* filePath = NULL;
	ITKCALL(PREF_ask_char_value("KSDY_MesIntegrateLog_Address", 0, &filePath));
	*logFile << "ѡKSDY_MesIntegrateLog_AddressΪ: " << (filePath ? filePath : "δ") << std::endl;

	if (filePath == NULL || strlen(filePath) == 0) {
		*logFile << "ѡKSDY_MesIntegrateLog_AddressδûΪա" << std::endl;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡKSDY_MesIntegrateLog_AddressδûΪա");
		return -1;
	}

	//Ŀµ϶
	int  attachments_num = 0;
	tag_t* attachments = NULLTAG;
	ITKCALL(EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments));
	//ƥ
	for (int i = 0; i < attachments_num; i++)
	{
		char* type = NULL;
		ITKCALL(AOM_ask_value_string(attachments[i], "object_type", &type));
		if (strcmp(type, "Dy2_DYDesignRevision") == 0)
		{
			int count = 0;
			tag_t* tags = NULL;
			ITKCALL(AOM_ask_value_tags(attachments[i], "IMAN_Rendering", &count, &tags));
			for (int j = 0; j < count;j++) {
				char* tagtype = NULL;
				
				ITKCALL(AOM_ask_value_string(tags[j], "object_type", &tagtype));
				
				*logFile << "ʼϵIMAN_Renderingȡ" << tagtype << std::endl;
				if (strcmp(tagtype,"ֱģ") == 0 || strcmp(tagtype, "DirectModel") == 0) {
					tag_t spec_dataset_rev = NULLTAG, ref_object = NULLTAG;
					AE_reference_type_t reference_type;
					ITKCALL(AE_ask_dataset_latest_rev(tags[j], &spec_dataset_rev));
					ITKCALL(AE_ask_dataset_named_ref2(spec_dataset_rev, "JTPART", &reference_type, &ref_object));
					if (reference_type != AE_PART_OF) {
						continue;
					}
					char* pathname = NULL, * origin_file_name = NULL, * new_ds_name = NULL;
					ITKCALL(WSOM_ask_name2(tags[j], &new_ds_name));
					*logFile << "new_ds_name" << new_ds_name << std::endl;
					ITKCALL(IMF_ask_file_pathname2(ref_object, SS_WNT_MACHINE, &pathname));
					*logFile << "pathname" << pathname << std::endl;
					ITKCALL(IMF_ask_original_file_name2(ref_object, &origin_file_name));
					*logFile << "origin_file_name" << origin_file_name << std::endl;
					char temp_file[SS_MAXPATHLEN] = "";
					char* temp_dir = getenv("temp");
					strcpy(temp_file, temp_dir);
					strcat(temp_file, "\\");
					strcat(temp_file, origin_file_name);
					string filestr2 = Utf8ToGbk(temp_file);
					*logFile << "filestr2" << filestr2 << std::endl;
					if ((_access(filestr2.c_str(), 0)) != -1) {
						if (!remove(filestr2.c_str())) {
							remove(filestr2.c_str());
						}
					}
					ITKCALL(IMF_export_file(ref_object, filestr2.c_str()));
					char* id = NULL;
					char* dy2_drawingRev = NULL;
					char* dy2_projectNum = NULL;
					char* dy2_projectName = NULL;
					char* dy2_productCode = NULL;
					ITKCALL(AOM_ask_value_string(attachments[i], "item_id", &id));
					ITKCALL(AOM_ask_value_string(attachments[i], "dy2_drawingRev", &dy2_drawingRev));
					ITKCALL(AOM_ask_value_string(attachments[i], "dy2_projectNum", &dy2_projectNum));
					ITKCALL(AOM_ask_value_string(attachments[i], "dy2_projectName", &dy2_projectName));
					ITKCALL(AOM_ask_value_string(attachments[i], "dy2_productCode", &dy2_productCode));
					if (*dy2_projectNum == '\0') {
						EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "Ŀ벻Ϊ");
						return -1;
					}
					if (*dy2_productCode == '\0') {
						EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "Ƽ벻Ϊ");
						return -1;
					}
					if (*dy2_drawingRev == '\0') {
						EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ļ汾Ϊ");
						return -1;
					}
					*logFile << "id" << id << std::endl;
					*logFile << "dy2_drawingRev" << dy2_drawingRev << std::endl;
					*logFile << "fileName" << origin_file_name << std::endl;
					*logFile << "dy2_projectNum" << dy2_projectNum << std::endl;
					*logFile << "dy2_projectName" << dy2_projectName << std::endl;
					*logFile << "dy2_productCode" << dy2_productCode << std::endl;
					char * request = sendPostRequest1(url, temp_file, dy2_projectNum, dy2_projectNum, id, dy2_productCode, dy2_drawingRev, origin_file_name);
					string requestData_new = Utf8ToGbk(request);
					*logFile << "requestData" << requestData_new << std::endl;
					requestData_new += "}";
					//洫ݲԼֵļ
					const char* info = extractValueFromJson1(requestData_new.c_str(), "info");
					*logFile << "info" << info << std::endl;
					const char* lastPart = extractLastPart1((const char*)url);
					*logFile << "lastPart" << lastPart << std::endl;
					char* time = getCurrentTime1();
					*logFile << "time" << time << std::endl;
					std::string fileName = std::string(lastPart) + "_" + std::string(info) + "_" + std::string(time);
					*logFile << "fileName" << fileName << std::endl;
					const char* logFolder = filePath;
					*logFile << "logFolder" << logFolder << std::endl;
					std::string logpath = std::string(filePath) + "\\" + fileName + ".txt";
					*logFile << "logpath" << logpath << std::endl;
					CreateDirectoryAndFile1(logFolder, logpath.c_str());
					//־ļΪ׷ģʽ
					auto logFile2 = std::make_unique<std::ofstream>(logpath, std::ios::app);
					logFile2->is_open();
					*logFile2 << "ݲ" << std::endl;
					*logFile2 << "ProjectCode" << "" << std::endl;
					*logFile2 << "ProjectName" << "" << std::endl;
					*logFile2 << "FileCode" << id << std::endl;
					*logFile2 << "FileVersion" << dy2_drawingRev << std::endl;
					*logFile2 << "ļַ" << temp_file << std::endl;
					
					*logFile2 << "ֵ" << requestData_new << std::endl;

					//const char* code = extractValueFromJson1(requestData_new.c_str(), "code");
					char codeValue[4]; // codeֵ3λֹ'\0'
					const char* startPos;
					// "code":ĺλλcodeֵʼλ
					startPos = strstr(requestData_new.c_str(), "\"code\":");
					if (startPos != NULL) {
						startPos += 7; // "code":ĸַĶźͿո
						strncpy(codeValue, startPos, 3); // 3ַcodeValueУȷᳬ߽
						codeValue[3] = '\0'; // ȷַβȷ
						*logFile << "code" << codeValue << std::endl;
					}
					else {
						printf("δҵcodeֵ\n");
					}
					if (strcmp(codeValue, "200") == 0) {
						//ִгɹ
					}
					else if (strcmp(codeValue, "400") == 0 || strcmp(codeValue, "500") == 0) {
						//ִʧ
						EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ͬ쳣");
						return -1;
					}
				}
			}
		}
	}
	return ITK_ok;
}