#define _CRT_SECURE_NO_WARNINGS
#define EPM_HANDLER_COMMON

#include <tccore/item.h>
#include <tccore/grmtype.h>
#include <tccore/grm.h>
#include <sa/am.h>
#include <tccore/aom.h>
#include <tccore/aom_prop.h>
#include <property/prop_errors.h>
#include <tccore/tctype.h>
#include <res/res_itk.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <vector>
#include "mdbks_register.h"
#include <chrono>
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
#include <sstream>
#include <tc\preferences.h>
#include <fstream>
#include <filesystem>
#include <windows.h>
#include <direct.h>

using namespace std;




#define MAX_BUFFER_SIZE 10000

size_t WriteCallback(void* contents, size_t size, size_t nmemb, void* userp) {
	size_t totalSize = size * nmemb;
	char* buffer = (char*)userp;
	size_t currentLength = strlen(buffer);

	// ʣռֹ
	if (currentLength + totalSize > MAX_BUFFER_SIZE) {
		printf("Error: Response too large for buffer!\n");
		return 0;
	}

	// ׷ݵ
	strncat(buffer, (char*)contents, totalSize - 1); // 1Ϊ˱'\0'λ
	buffer[currentLength + totalSize - 1] = '\0'; // ӽ

	return totalSize;
}

char* sendPostRequest(const char* jsonPayload, const char* url) {
	CURL* curl;
	CURLcode res;
	char readBuffer[MAX_BUFFER_SIZE];
	memset(readBuffer, 0, MAX_BUFFER_SIZE);
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url);
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "http");
		struct curl_slist* headers = NULL;

		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, readBuffer);

		headers = curl_slist_append(headers, "Content-Type: application/json");
		headers = curl_slist_append(headers, "Cookie: JSESSIONID=64EF3E9DDE22D9A15B9586AC83E60F15");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);

		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, jsonPayload);

		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0L); // ֹ֤Զ֤
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0L); // ֹ֤
		res = curl_easy_perform(curl);

		if (res != CURLE_OK) {
			fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
			return NULL;
		}

		curl_slist_free_all(headers);
		curl_easy_cleanup(curl);
	}
	else {
		printf("Failed to initialize curl.\n");
		return NULL;
	}

	return readBuffer;
}

// ԭͣһµַвԭַеκοո
char* removeSpaces(const char* input) {
	if (!input) return NULL;

	// ȼȥոַ
	int lenWithoutSpaces = 0;
	for (const char* p = input; *p; ++p) {
		if (*p != ' ') {
			++lenWithoutSpaces;
		}
	}

	// 㹻ڴַ
	char* output = (char*)malloc(lenWithoutSpaces + 1);
	if (!output) return NULL;

	// Ʋոַַ
	int index = 0;
	for (const char* q = input; *q; ++q) {
		if (*q != ' ') {
			output[index++] = *q;
		}
	}
	output[index] = '\0'; // ֹ

	return output;
}


#define MAX_ATTR_LENGTH 100 // 󳤶
//jsonеtokenϢ
const char* extractValueFromJson(const char* response, const char* attr) {
	// Ƴпո
	char* response2 = removeSpaces(response);
	printf("response2: %s\n", response2);

	// ʹþ̬飬עattrᳬMAX_ATTR_LENGTHַ
	char attr_with_quotes[2 * MAX_ATTR_LENGTH + 3]; // ˫źð
	snprintf(attr_with_quotes, sizeof(attr_with_quotes), "\"%s\":\"", attr);
	sprintf(attr_with_quotes, "\"%s\":\"", attr);

	const char* value_start = strstr(response2, attr_with_quotes);
	if (value_start == NULL) {
		return NULL; // attr δҵ
	}
	value_start += strlen(attr_with_quotes); // ƶָ뵽ֵʼλ

	const char* value_end = strchr(value_start, '"');
	if (value_end == NULL) {
		return NULL; // ˫δҵ
	}

	// ȷҵǽֵ˫ţǶֵڵ˫
	if (*(value_end - 1) == '\\') {
		do {
			value_end = strchr(value_end + 1, '"');
			if (value_end == NULL) {
				return NULL; // ת˫ţδҵת˫ţ򷵻ش
			}
		} while (*(value_end - 1) == '\\');
	}

	size_t value_length = value_end - value_start;
	char* value = (char*)malloc((value_length + 1) * sizeof(char));
	if (value == NULL) {
		return NULL; // ڴʧ
	}
	strncpy(value, value_start, value_length);
	value[value_length] = '\0'; // ֹ
	printf("value: %s\n", value);

	// ʱ
	free(response2);

	return value;
}


void CreateDirectoryAndFile(const char* directory_path, const char* file_path) {
	// Ŀ¼·תΪַ
	wchar_t w_directory_path[MAX_PATH];
	MultiByteToWideChar(CP_UTF8, 0, directory_path, -1, w_directory_path, MAX_PATH);

	// ļǷڣ򴴽
	DWORD dwAttrib = GetFileAttributes(w_directory_path);
	if (dwAttrib == INVALID_FILE_ATTRIBUTES || !(dwAttrib & FILE_ATTRIBUTE_DIRECTORY)) {
		// ļвڣԴ
		if (_wmkdir(w_directory_path) != 0) {
			perror("Failed to create directory.");
			return;
		}
	}

	// ļ·תΪַ
	wchar_t w_file_path[MAX_PATH];
	MultiByteToWideChar(CP_UTF8, 0, file_path, -1, w_file_path, MAX_PATH);

	// ļǷڣ򴴽
	FILE* file = fopen(file_path, "r");
	if (file == NULL) {
		// ļڣԴ򿪣׷ģʽ򿪣
		file = fopen(file_path, "a+");
		if (file == NULL) {
			perror("Failed to create and open file.");
			return;
		}
		fclose(file); // رոմļ
	}
	else {
		fclose(file); // ļѴڣرմ򿪵ļ
	}
}

const char* extractLastPart(const char* url) {
	if (url == nullptr) return nullptr;

	// һ '/' λ
	const char* lastSlash = strrchr(url, '/');

	// Ҳ '/', ԭַҪĲ
	if (lastSlash == nullptr) return url;

	// ƶ '/' ĵһַӴʼλ
	return lastSlash + 1;
}

char* getCurrentTime() {
	time_t nowtime;
	time(&nowtime); // ȡǰʱ䣨197011
	tm* p = localtime(&nowtime); // תΪʱ

	// ̬仺ȷ㹻ɸʽʱַ
	char* timeStr = (char*)malloc(sizeof(char) * 14); // ʽΪ"YYYYMMDDHHMMSS"14ַ+1'\0'
	if (timeStr == NULL) {
		perror("Memory allocation failed");
		return NULL;
	}

	// ʹsnprintfʽʱ䵽
	int len = snprintf(timeStr, 14, "%04d%02d%02d%02d%02d", p->tm_year + 1900, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min);
	if (len < 0) {
		perror("Failed to format time");
		free(timeStr);
		return NULL;
	}
	else if (len > 14) {
		//ϲᷢΪΪ14ԿӴ˼
		perror("Formatted time exceeds buffer size");
		free(timeStr);
		return NULL;
	}

	return timeStr;
}

/**
 *
 * @HandlerName: KSDY_Material2MES
 * @HandlerType: ActionHandler
 * @Description: ͨhandleϢMES
 * @author: hcj
 * @date: 2024520
 *
 */
int KSDY_Material2MES(EPM_action_message_t msg) {

	//ȡ
	tag_t rootTask = NULLTAG;
	EPM_ask_root_task(msg.task, &rootTask);
	//ļкļǷ 򴴽
	const char* directory_path = "D:\\log";
	const char* file_path = "D:\\log\\KSDY_Material2MES.log";
	CreateDirectoryAndFile(directory_path, file_path);

	//־ļΪ׷ģʽ
	auto logFile = std::make_unique<std::ofstream>("D:\\log\\KSDY_Material2MES.log", std::ios::app);
	logFile->is_open();

	//ȡǰʱ
	auto now = std::chrono::system_clock::now();
	std::time_t time1 = std::chrono::system_clock::to_time_t(now);
	std::string timeStr = std::ctime(&time1);
	*logFile << "[" << timeStr.substr(0, timeStr.size() - 1) << "] ";
	*logFile << "=========================MESstart===================" << std::endl;

	//ȡѡ
	char* url = NULL;
	ITKCALL(PREF_ask_char_value("KSDY_TC2MES_URL", 0, &url));
	*logFile << "ѡKSDY_TC2MES_URLΪ: " << (url ? url : "δ") << std::endl;

	if (url == NULL || strlen(url) == 0) {
		*logFile << "ѡKSDY_TC2MES_URLδûΪա" << std::endl;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡKSDY_TC2MES_URLδûΪա");
		return -1;
	}
	else {
		// ȷurlЧٵextractMaterialInfo
		url = extractMaterialInfo(url, "Material:");
		if (url) {
			*logFile << "ȡMaterialϢɹ: " << url << std::endl;
		}
		else {
			*logFile << "δܴѡȡMaterialϢ" << std::endl;
			// 򷵻ش
		}
	}
	*logFile << "ѡKSDY_TC2MES_URL" << url << std::endl;

	char* filePath = NULL;
	ITKCALL(PREF_ask_char_value("KSDY_MesIntegrateLog_Address", 0, &filePath));
	*logFile << "ѡKSDY_MesIntegrateLog_AddressΪ: " << (filePath ? filePath : "δ") << std::endl;

	if (filePath == NULL || strlen(filePath) == 0) {
		*logFile << "ѡKSDY_MesIntegrateLog_AddressδûΪա" << std::endl;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ѡKSDY_MesIntegrateLog_AddressδûΪա");
		return -1;
	}

	//json
	char* attrArray[] = { "item_id","object_name","dy2_partClass","dy2_materialTrademark","dy2_supply","dy2_material","uom_tag","",
		"owning_user" ,"object_desc" ,"dy2_partSource" ,"dy2_ecolor" ,"item_id" ,"dy2_surfaceTreatment" ,"" ,"" ,"dy2_weight2" ,
		"dy2_weight1" ,"dy2_supply" ,"dy2_wunit" ,"dy2_length" ,"dy2_width" ,"dy2_height" ,"dy2_size" ,"dy2_sunit" ,"dy2_cPurchase" ,
		"dy2_cSale" ,"dy2_cStock" ,"dy2_cProduce"  ,"dy2_cOut"  ,"dy2_cTransfer" };//tc
	char* jsonAttr[] = { "MICode","MIName","MTID","MISize","MIPinPai","MICaiZhi","MIUnit","MIManageUser","MICreateUser","MIRemark" ,
		"attribute" ,"color" ,"tuhao" ,"bmcl" ,"ydyq" ,"zl" ,"mz" ,"jz" ,"supplier" ,"zlunit" ,"chang" ,"kuan" ,"gao" ,"tiji" ,
		"sizeunit" ,"yxcg" ,"yxxs" ,"yxkc" ,"yxsc" ,"yxww" ,"yxzczy"  };//json

	//Ŀµ϶
	int  attachments_num = 0;
	tag_t* attachments = NULLTAG;
	ITKCALL(EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments));

	*logFile << "ʼJSON" << std::endl;
	// JSONַ
	string json_data = "[";

	//ƥ
	for (int i = 0; i < attachments_num; i++)
	{
		char* type = NULL;
		ITKCALL(AOM_ask_value_string(attachments[i], "object_type", &type));
		*logFile << "ʼȡ" << type << std::endl;
		if (strcmp(type, "Dy2_DYPartRevision") == 0)
		{
			json_data += "{";
			//ƴӶJSON
			*logFile << "ƴӶJSON" << std::endl;
			for (int j = 0; j < sizeof(attrArray) / sizeof(attrArray[0]); j++) {
				*logFile << "ʼȡ" << attrArray[j] << std::endl;
				json_data += "\"";
				json_data += jsonAttr[j];
				json_data += "\":";
				char* attrValue = NULL;
				if (strcmp(attrArray[j], "uom_tag") == 0) {
					//ȡλ
					tag_t item = NULLTAG;
					ITKCALL(ITEM_ask_item_of_rev(attachments[i], &item));
					tag_t dw = NULLTAG;
					ITKCALL(AOM_ask_value_tag(item, "uom_tag", &dw));
					if (dw == NULLTAG) {
						attrValue = "";
					}
					else {
						ITKCALL(AOM_ask_value_string(dw, "object_string", &attrValue));
					}
					
				}
				else if (strcmp(attrArray[j], "owning_user") == 0) {
					tag_t root_tag = NULLTAG;
					ITKCALL(AOM_ask_value_tag(attachments[i], "owning_user", &root_tag));
					if (root_tag == NULLTAG) {
						printf("δҵ\n");
					}
					ITKCALL(AOM_ask_value_string(root_tag, "user_name", &attrValue));
				}
				else if (strcmp(attrArray[j], "") == 0) {
					attrValue = "";
				}
				else {
					ITKCALL(AOM_ask_value_string(attachments[i], attrArray[j], &attrValue));
				}
				if (attrValue == NULL) {
					attrValue = "";
				}
				*logFile << "ֵΪ" << attrValue << std::endl;
				json_data += "\"";
				json_data += GbkToUtf8(attrValue);
				json_data += "\"";
				if (j != ((sizeof(attrArray) / sizeof(attrArray[0]))-1)) {
					json_data += ",";
				}
			}
			json_data += "}";
			json_data += ",";
		}
	}

	if (strcmp(json_data.c_str(), "[") == 0) {
		return 0;
	}

	//ɾһ
	if (!json_data.empty()) json_data.pop_back();

	json_data += "]";

	*logFile << "json_data" << Utf8ToGbk(json_data.c_str()) << std::endl;
	*logFile << "ʼpostMES" << std::endl;

	*logFile << "url" << url << std::endl;

	//postmes
	char* request = sendPostRequest(json_data.c_str(), url);

	string requestData_new = Utf8ToGbk(request);
	requestData_new += "}";
	*logFile << "requestData" << requestData_new << std::endl;
	
	
	//洫ݲԼֵļ
	const char* info = extractValueFromJson(requestData_new.c_str(), "info");
	*logFile << "info" << info << std::endl;
	const char* lastPart = extractLastPart((const char*)url);
	*logFile << "lastPart" << lastPart << std::endl;
	char* time = getCurrentTime();
	*logFile << "time" << time << std::endl;
	std::string fileName = std::string(lastPart) + "_" + std::string(info) + "_" + std::string(time);
	*logFile << "fileName" << fileName << std::endl;

	*logFile << "ʼ־ļ" << std::endl;
	const char* logFolder = filePath;
	*logFile << "logFolder" << logFolder << std::endl;
	std::string logpath = std::string(filePath) + "\\" + fileName + ".txt";
	*logFile << "logpath" << logpath << std::endl;
	CreateDirectoryAndFile(logFolder, logpath.c_str());
	//־ļΪ׷ģʽFF
	auto logFile2 = std::make_unique<std::ofstream>(logpath, std::ios::app);
	logFile2->is_open();
	*logFile2 << "ݲ" << Utf8ToGbk(json_data.c_str()) << std::endl;
	*logFile2 << "ֵ" << requestData_new << std::endl;

	//const char* code = extractValueFromJson(requestData_new.c_str(), "code");
	char codeValue[4]; // codeֵ3λֹ'\0'
	const char* startPos;

	// "code":ĺλλcodeֵʼλ
	startPos = strstr(requestData_new.c_str(), "\"code\":");
	if (startPos != NULL) {
		startPos += 7; // "code":ĸַĶźͿո
		strncpy(codeValue, startPos, 3); // 3ַcodeValueУȷᳬ߽
		codeValue[3] = '\0'; // ȷַβȷ
		*logFile << "code" << codeValue << std::endl;
	}
	else {
		printf("δҵcodeֵ\n");
	}
	*logFile << "code" << codeValue << std::endl;
	if (strcmp(codeValue,"200") == 0) {
		//ִгɹ
	}
	else if (strcmp(codeValue, "400") == 0 || strcmp(codeValue, "500") == 0) {
		//ִʧ
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, "ͬ쳣");
		return -1;
	}

	return ITK_ok;
}